breeds [redarmy bluearmy redhorse bluehorse redtank bluetank redgeneral bluegeneral]

to setup
  ca
  ask patches with [abs pxcor = screen-edge-x or
                    abs pycor = screen-edge-y]
        [ set pcolor green - 3 ]
  create-custom-redarmy red-infantry
  [set color red set shape "person" set size 2
   setxy (random-float screen-size-x / 2)
            (random-float screen-size-y)
      set heading (250 + random 40)]
  create-custom-bluearmy blue-infantry
  [set color blue set shape "person" set size 2
   setxy (random-float (- screen-size-x) / 2)
            (random-float screen-size-y)
      set heading (70 + random 40)]
  create-custom-redhorse red-cavalry
  [set color red + 1 set shape "wolf-left" set size 2
   setxy (random-float screen-size-x / 2)
            (random-float screen-size-y)
      set heading (250 + random 40)]
  create-custom-bluehorse blue-cavalry
  [set color blue + 1 set shape "wolf-right" set size 2
   setxy (random-float (- screen-size-x) / 2)
            (random-float screen-size-y)
      set heading (70 + random 40)]
  create-custom-redtank red-tank
  [set color red + 1 set shape "tank-left" set size 3
   setxy (random-float screen-size-x / 2)
            (random-float screen-size-y)
      set heading (250 + random 40)]
  create-custom-bluetank blue-tank
  [set color blue + 1 set shape "tank-right" set size 3
   setxy (random-float (- screen-size-x) / 2)
            (random-float screen-size-y)
      set heading (70 + random 40)]
  if generals? 
     [create-custom-redgeneral 3
       [set color violet + 2 set shape "person" set size 2
        setxy (screen-edge-x / 2)
              (random-float screen-size-y)
        set heading 270]
      create-custom-bluegeneral 3  
        [set color violet - 2 set shape "person" set size 2
        setxy ((- screen-edge-x)/ 2)
              (random-float screen-size-y)
        set heading 90]] 
  setup-plot   
  ifelse quicksetup?
  [print "On your orders, sir."] 
  [print "Greetings, Commander" wait 1
  print "Preparing Armies" wait 1
  repeat 100 [write random 10]
  print ""
  print "Armies ready" wait 1
  print "On your orders, sir."]
end

to go
  update-plot
  ask turtles with [color = white] [die]
  ifelse not any? turtles with [color = blue] and 
  not any? turtles with [color = red]
  [print "Wipeout!"]
  [ask turtles [victory]]
  if not any? turtles with [color = blue] or 
  not any? turtles with [color = red]
  [stop]
  ask turtles [ move ]
  extras
end

to move 
  locals [x y z]
  ask turtles with [pxcor = screen-edge-x]
    [set heading (250 + random 40)]
  ask turtles with [pxcor = (- screen-edge-x)]
    [set heading (70 + random 40)]
  ask turtles with [pycor = screen-edge-y]
    [set heading (160 + random 40)]
  ask turtles with [pycor = (- screen-edge-y)]
    [set heading (-20 + random 40)]
  ask bluearmy [fd 1]
  ask redarmy [fd 1]
  ask bluehorse [fd 3]
  ask redhorse [fd 3]
  ask bluetank [fd 2]
  ask redtank [fd 2]
  set x random 2
  ifelse x = 0
    [kill-infantry-blue
    kill-infantry-red]
    [kill-infantry-red
    kill-infantry-blue]
  victory
  set y random 2
  ifelse y = 0
    [kill-horse-blue
    kill-horse-red]
    [kill-horse-red
    kill-horse-blue]
  victory
  set z random 2
  ifelse z = 0
    [kill-tank-blue
    kill-tank-red]
    [kill-tank-red
    kill-tank-blue]
  victory
end



to extras
  ifelse any? turtles with [color = red]  
  [every reinforce-rate [create-custom-redarmy reinforcements
    [set color red set shape "person" set size 2
        setxy (random-float screen-size-x / 2)
              (random-float screen-size-y)
        set heading 250 + random 20]]]
   [ask turtles [set heading heading]]
  ifelse any? turtles with [color = blue]
  [every reinforce-rate [create-custom-bluearmy reinforcements
    [set color blue set shape "person" set size 2
        setxy (random-float (- screen-size-x) / 2)
              (random-float screen-size-y)
        set heading 70 + random 20]]]
    [ask turtles [set heading heading]]
end

;MONITOR AND PLOTTING

to-report blue-army
  report count turtles with [color = blue or color = blue + 1 or color = violet - 2]
end

to-report red-army
  report count turtles with [color = red or color = red + 1 or color = violet + 2]
end

to setup-plot
  set-current-plot "Armies"
end

to update-plot
  set-current-plot "Armies"
  set-current-plot-pen "Blue Army"
  plot count turtles with [color = blue or color = blue + 1 or color = violet - 2]
  set-current-plot-pen "Red Army"
  plot count turtles with [color = red or color = red + 1 or color = violet + 2] 
end






;KILL COMMANDS

to kill-infantry-blue
  locals [a]
  ifelse any? bluearmy
  [set a vision
    while [a > 0]
     [ask redarmy-on patch-ahead (a + random morale-bonus) [die]          ;takes vision + morale randomized
      ask redhorse-on patch-ahead (a + random morale-bonus) [die]
      ask redtank-on patch-ahead (a + random morale-bonus) [die]
      if generals? [
         ask redgeneral-on patch-ahead (a + random morale-bonus) [die]
         ifelse any? redgeneral
         [set heading heading]
         [red-general-die
          ask turtles with [color = red and xcor < 0] [die]]]
       set a a - 1
       set pcolor-of patch-here red - 3]]
  [set heading heading]
end

to kill-infantry-red
  locals [b]
  ifelse any? redarmy
  [set b vision   
    while [b > 0]
     [ask bluearmy-on patch-ahead (b + random morale-bonus) [die]
      ask bluehorse-on patch-ahead (b + random morale-bonus) [die]
      ask bluetank-on patch-ahead (b + random morale-bonus) [die]
      if generals? [
         ask bluegeneral-on patch-ahead (b + random morale-bonus) [die]
         ifelse any? bluegeneral
         [set heading heading]
         [blue-general-die
          ask turtles with [color = blue and xcor > 0] [die]]]
        set b b - 1
        set pcolor-of patch-here red - 3]]
  [set heading heading]   
end

to kill-horse-blue
  locals [c]
  ifelse any? bluehorse
  [set c vision
    while [c > 0]
     [ask redarmy-on patch-ahead (c + random morale-bonus - 1) [die]          ;takes vision + morale randomized - 1
      ask redhorse-on patch-ahead (c + random morale-bonus - 1) [die]
      ask redtank-on patch-ahead (c + random morale-bonus - 1) [die]
      if generals? [
         ask redgeneral-on patch-ahead (c + random morale-bonus - 1) [die]
         ifelse any? redgeneral
         [set heading heading]
         [red-general-die
          ask turtles with [color = red and xcor < 0] [die]]]
       set c c - 1
       set pcolor-of patch-here red - 3]]
  [set heading heading]
end


to kill-horse-red
  locals [d]
  ifelse any? redhorse
  [set d vision   
    while [d > 0]
     [ask bluearmy-on patch-ahead (d + random morale-bonus - 1) [die]
      ask bluehorse-on patch-ahead (d + random morale-bonus - 1) [die]
      ask bluetank-on patch-ahead (d + random morale-bonus - 1) [die]
      if generals? [
         ask bluegeneral-on patch-ahead (d + random morale-bonus - 1) [die]
         ifelse any? bluegeneral
         [set heading heading]
         [blue-general-die
          ask turtles with [color = blue and xcor > 0] [die]]]
        set d d - 1
        set pcolor-of patch-here red - 3]]
  [set heading heading]   
end



to kill-tank-blue
  locals [ea]
  ifelse any? bluetank
  [set ea vision   
    while [ea > 0]
     [ask redarmy-on patch-ahead (ea + random (morale-bonus + 1) + 2) [die]          ;takes vision + morale+1 randomized + 2
      ask redhorse-on patch-ahead (ea + random (morale-bonus + 1) + 2) [die]
      ask redtank-on patch-ahead (ea + random (morale-bonus + 1) + 2) [die]
      hatch 1 [set color white set shape "circle" set size 2
               setxy (pxcor)(pycor)]
      if generals? [
         ask redgeneral-on patch-ahead (ea + random (morale-bonus + 1) + 2) [die]
         ifelse any? redgeneral
         [set heading heading]
         [red-general-die
          ask turtles with [color = red and xcor < 0] [die]]]
        set ea ea - 1
        set pcolor-of patch-here red - 3]]
  [set heading heading]   
end
  
to kill-tank-red
  locals [f]
  ifelse any? redtank
  [set f vision   
    while [f > 0]
     [ask bluearmy-on patch-ahead (f + random (morale-bonus + 1) + 2) [die]
      ask bluehorse-on patch-ahead (f + random (morale-bonus + 1) + 2) [die]
      ask bluetank-on patch-ahead (f + random (morale-bonus + 1) + 2) [die]
      hatch 1 [set color white set shape "circle" set size 2
               setxy (pxcor)(pycor)]
      if generals? [
         ask bluegeneral-on patch-ahead (f + random (morale-bonus + 1) + 2) [die]
         ifelse any? bluegeneral
         [set heading heading]
         [blue-general-die
          ask turtles with [color = blue and xcor > 0] [die]]]
        set f f - 1
        set pcolor-of patch-here red - 3]]
  [set heading heading]   
end

to blue-general-die
  every 30 [print "Blue General has fallen! Blue Army in dismay!"]
  stop
end  

to red-general-die
  every 30 [print "Red General has fallen! Red Army in dismay!"]
  stop
end  
  
  
;VICTORY COMMAND

to victory
  ifelse any? turtles with [color = blue or color = blue + 1]
    [set heading heading]
    [print "Red Victory!"]
  ifelse any? turtles with [color = red or color = red + 1]
    [set heading heading]
    [print "Blue Victory!"]
  ifelse any? turtles
    [set heading heading]
    [print "Wipeout!"]  
  stop
end
  



@#$#@#$#@
GRAPHICS-WINDOW
495
10
949
485
18
18
12.0
1
10
1
1
1

CC-WINDOW
240
95
484
253
Command Center

BUTTON
22
42
140
75
Prepare Armies
setup
NIL
1
T
OBSERVER
T

BUTTON
139
42
220
75
Engage
go
T
1
T
OBSERVER
T

SLIDER
9
75
232
108
red-infantry
red-infantry
10
100
10
5
1
Men

SLIDER
9
376
232
409
vision
vision
1
10
5.0
0.5
1
patches

SLIDER
9
108
232
141
blue-infantry
blue-infantry
10
100
10
5
1
Men

TEXTBOX
69
10
193
40
Army by Michael Lam

SLIDER
9
273
232
306
morale-bonus
morale-bonus
0
3
1
1
1
Points

SLIDER
9
306
232
339
reinforcements
reinforcements
0
50
10
1
1
Men

SLIDER
9
207
232
240
red-tank
red-tank
0
5
0
1
1
Tanks

SLIDER
9
240
232
273
blue-tank
blue-tank
0
5
0
1
1
Tanks

SLIDER
9
141
232
174
red-cavalry
red-cavalry
0
30
0
1
1
Horses

SLIDER
9
174
232
207
blue-cavalry
blue-cavalry
0
30
0
1
1
Horses

SWITCH
312
52
425
85
Generals?
Generals?
0
1
-1000

SLIDER
9
339
232
372
reinforce-rate
reinforce-rate
1
5
1.0
0.25
1
Time-unit

SWITCH
308
10
431
43
quicksetup?
quicksetup?
0
1
-1000

MONITOR
280
266
351
315
Blue Army
blue-army
3
1

MONITOR
373
267
442
316
Red Army
red-army
3
1

PLOT
242
328
492
500
Armies
Time
Men
0.0
100.0
0.0
100.0
true
false
PENS
"Blue Army" 1.0 0 -16776961 true
"Red Army" 1.0 0 -65536 true

@#$#@#$#@
Army by Michael Lam

A Military Simulation Program
Uses Differnet variables to show the victor of a conflict/skirmish.
Infantry - Basic movement and attack-range.
Cavalry - Quick movement and shorter attack-range.
Tanks - Medium movement and long attack-range.
Generals - If killed, throw army into dismay.

Morale-bonus - Boosts morale and combat efficency
Reinforcements - Number of reinforcements per reinforce rate
Vision - Basis for Range of attack

Good Luck, Commander.



Tanks based upon Truck shapes. Horses use Wolf shapes. People use People shapes.
All provided by NetLogo

Originally based upon NetLogo Flocking Model

Copyright 1998 by Uri Wilensky.  All rights reserved.  See http://ccl.northwestern.edu/netlogo/models/Flocking for terms of use.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7566196 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 35 35 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

tank-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210
Rectangle -7566196 true true 136 121 210 144
Rectangle -7566196 true true 166 105 180 125
Rectangle -7566196 true true 106 90 195 105
Rectangle -7566196 true true 166 75 196 90
Rectangle -7566196 true true 162 90 210 104
Rectangle -7566196 true true 186 101 210 105
Rectangle -7566196 true true 168 104 196 138

tank-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210
Rectangle -7566196 true true 91 120 150 148
Rectangle -7566196 true true 106 105 135 129
Rectangle -7566196 true true 91 90 195 105
Rectangle -7566196 true true 106 75 135 93

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7566196 true true 15 105 105 165
Rectangle -7566196 true true 45 90 105 105
Polygon -7566196 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7566196 true true 105 120 263 195
Rectangle -7566196 true true 108 195 259 201
Rectangle -7566196 true true 114 201 252 210
Rectangle -7566196 true true 120 210 243 214
Rectangle -7566196 true true 115 114 255 120
Rectangle -7566196 true true 128 108 248 114
Rectangle -7566196 true true 150 105 225 108
Rectangle -7566196 true true 132 214 155 270
Rectangle -7566196 true true 110 260 132 270
Rectangle -7566196 true true 210 214 232 270
Rectangle -7566196 true true 189 260 210 270
Line -7566196 true 263 127 281 155
Line -7566196 true 281 155 281 192

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.0.2
@#$#@#$#@
set population 200
setup
repeat 200 [ go ]
@#$#@#$#@
@#$#@#$#@
